#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    // BGG audio stuff
    int sr = 44100;
    int nbufs = 2; // you can use more for more processing but latency will suffer
    
    nchans = 2;
    framesize = 512;
    
    s_audio_outbuf = (short*)malloc(nchans*framesize*sizeof(short));
    s_audio_inbuf = (short*)malloc(nchans*framesize*sizeof(short));

    // initialize RTcmix
	rtcmixmain();
	maxmsp_rtsetparams(sr, nchans, framesize, NULL, NULL);
    
    ofSoundStreamSetup(nchans, 1, sr, framesize, nbufs); // out & in(mono) nchans
    ofSoundStreamStart();

}

void ofApp::audioReceived(float * input, int bufferSize, int nChannels) {
    for (int i = 0; i < framesize*nchans; i++) {
         // transfer to the short s_audio_inbuf (mono in, stereo to RTcmix)
        s_audio_inbuf[i*2] = (input[i]*32768.0);
        s_audio_inbuf[i*2+1] = (input[i]*32768.0);
    }
}

void ofApp::audioRequested(float * output, int bufferSize, int nChannels) {
    pullTraverse(s_audio_inbuf, s_audio_outbuf);
    
    for (int i = 0; i < framesize*nchans; i++)
        output[i] = (float)s_audio_outbuf[i]/32786.0; // transfer to the float *output buf
    
    
    if (check_bang() == 1) {
    }
    
    char *pbuf = get_print();
    char *pbufptr = pbuf;
    while (strlen(pbufptr) > 0) {
        ofLog() << pbufptr;
        pbufptr += (strlen(pbufptr) + 1);
    }
    reset_print();
}


//--------------------------------------------------------------
void ofApp::update(){

}

//--------------------------------------------------------------
void ofApp::draw(){
	
}

//--------------------------------------------------------------
void ofApp::exit(){

}

//--------------------------------------------------------------
void ofApp::touchDown(ofTouchEventArgs & touch){
    char *thescore = { " \
        rtinput(\"AUDIO\") \
        \
        PANECHO(0, 0, 999, 1, 0.2, 0.3, 0.7, 0, 1) \
        "};
    parse_score(thescore, strlen(thescore));
}

//--------------------------------------------------------------
void ofApp::touchMoved(ofTouchEventArgs & touch){

}

//--------------------------------------------------------------
void ofApp::touchUp(ofTouchEventArgs & touch){
    flush_sched();
}

//--------------------------------------------------------------
void ofApp::touchDoubleTap(ofTouchEventArgs & touch){

}

//--------------------------------------------------------------
void ofApp::touchCancelled(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::lostFocus(){

}

//--------------------------------------------------------------
void ofApp::gotFocus(){

}

//--------------------------------------------------------------
void ofApp::gotMemoryWarning(){

}

//--------------------------------------------------------------
void ofApp::deviceOrientationChanged(int newOrientation){

}

